var test = (function(lib, lineatiempo, events){

	var test = {};

	// ********** Propiedades de test. **********

	test.scrollCentros = 100;

	test.circulos = [
		// Circulo 1
		{
			radius: 100,
			scrollInit: test.scrollCentros,
			scrollEnd: test.scrollCentros + 300
		},
		// Circulo 1 - texto
		{
			radius: 200,
			scrollInit: test.scrollCentros + 600,
			scrollEnd: test.scrollCentros + 900
		},
		// Circulo 2
		{
			radius: 300,
			scrollInit: test.scrollCentros + 1200,
			scrollEnd: test.scrollCentros + 1500
		},
		// Circulo 2 - texto
		{
			radius: 400,
			scrollInit: test.scrollCentros + 1800,
			scrollEnd: test.scrollCentros + 2100
		},
		// Circulo 3
		{
			radius: 500,
			scrollInit: test.scrollCentros + 2400,
			scrollEnd: test.scrollCentros + 2700
		},
		// Circulo 3 - texto
		{
			radius: 600,
			scrollInit: test.scrollCentros + 3000,
			scrollEnd: test.scrollCentros + 3300
		}
	];
	test.circulosColor = 'red';

	test.camino = [
	//Camino 1
{x: 1743,y:471,r:40},
{x: 1738,y:540,r:10},
{x: 1725,y:577,r:10},
{x: 1712,y:620,r:10},
{x: 1693,y:664,r:10},
{x: 1672,y:694,r:10},
{x: 1640,y:724,r:10},
{x: 1608,y:748,r:10},
{x: 1565,y:769,r:10},
{x: 1521,y:783,r:10},
{x: 1478,y:796,r:10},
{x: 1428,y:816,r:10},
{x: 1383,y:833,r:10},
{x: 1343,y:849,r:10},
{x: 1291,y:862,r:10},
{x: 1240,y:874,r:10},
{x: 1186,y:889,r:10},
{x: 1138,y:904,r:10},
{x: 1086,y:917,r:10},
{x: 1043,y:935,r:10},
{x: 1002,y:964,r:10},
{x: 974,y:994,r:10},
{x: 954,y:1031,r:10},
{x: 943,y:1071,r:10},
//Camino 2
{x:936,y:8,r:10    },
{x:893,y:34,r:10   },
{x:843,y:55,r:10   },
{x:805,y:83,r:10   },
{x:772,y:120,r:10  },
{x:751,y:157,r:10  },
{x:740,y:197,r:10  },
];
test.camino2 = [
//Camino 3
{x:706,y:612,r:40},
{x:702,y:659,r:10},
{x:700,y:689,r:10},
{x:701,y:737,r:10},
{x:685,y:766,r:10},
{x:638,y:775,r:10},
{x:591,y:782,r:10},
{x:536,y:786,r:10},
{x:482,y:802,r:10},
{x:462,y:846,r:10},
{x:448,y:875,r:10},
{x:449,y:922,r:10},
{x:495,y:941,r:10},
{x:540,y:946,r:10},
{x:581,y:949,r:10},
{x:641,y:947,r:10},
{x:695,y:947,r:10},
{x:751,y:946,r:10},
{x:800,y:939,r:10},
{x:852,y:926,r:10},
{x:898,y:892,r:10},
{x:918,y:843,r:10},
{x:890,y:823,r:10},
{x:845,y:795,r:10},
{x:806,y:781,r:10},
{x:740,y:770,r:10},
]
test.camino3 = [
//Camino 4
{x:959,y:825,r:10},
{x:997,y:795,r:10},
{x:1034,y:762,r:10},
{x:1068,y:727,r:10},
{x:1103,y:694,r:10},
{x:1133,y:661,r:10},
{x:1168,y:640,r:10},
{x:1209,y:630,r:10},
{x:1255,y:624,r:10},
];




	// ********** Funciones de test. **********
	test.canvas = document.getElementById('canvas');
	test.i = 0;
	// Animacion de camino
	test.renderCamino = function(scroll) {

		var ctx = test.canvas.getContext('2d');
		ctx.canvas.height = lib.screenHeight;
		ctx.canvas.width  = lib.screenWidth;
		var sy = lib.screenHeight / 1080;
		var sx = lib.screenWidth / 1920;
		//Dibuja un Circulo
		var drawPath = function(x, y, maxRadius)
		{
			ctx.beginPath();
			ctx.arc(x, y, maxRadius, 0, 2 * Math.PI, false);
			ctx.closePath();
			ctx.fillStyle = '#f68529';
			ctx.fill();
		}

		ctx.clearRect(0,0, canvas.width, canvas.height);
		//Road Var
		var frameWidth = 2000 / test.camino.length; //Largol de cada fotograma con respecto al scroll
		//Total de fotogramas
		var frame = (scroll.curTop < 2000) ? Math.trunc(scroll.curTop / frameWidth) : test.camino.length - 1;
		var slide = scroll.curTop * 0.4;
		var i = 0;

		//Baby Var
		var alphaFB = (scroll.curTop - 2200) / 1600 * 0.8;
		var motionFondoBebe = $('#motion-fondo-bebe')[0];
		var alphaB = (scroll.curTop - 3900) / 1600 * 0.8;
		var motionBebe = $('#motion-bebe')[0];

		//Hallux
		var alphaH = (scroll.curTop - 6400) / 1600 * 0.8;
		var motionHallux = $('#motion-hallux')[0];

		//Juanete
		var alphaJ = (scroll.curTop - 9000) / 1600 * 0.8;
		var motionJuanete = $('#motion-juanete')[0];
		//Dibuja el primer PATH desplazando el camino hacia arriba
		for(i = 0; i < frame; i++) {
			slide = (slide < ctx.canvas.height) ? slide : ctx.canvas.height;
			var y = sy * test.camino[i].y - slide;
			if(i > 23)
				y = y + canvas.height + 15;
				var x = sx * test.camino[i].x;
				var radius = sx * test.camino[i].r;

				drawPath(x, y, radius);
			}

		//Dibuja el Contorno del Bebe aumentando el alpha segun el scroll
		if(scroll.curTop <= 2200)
		{
			ctx.globalAlpha = 0;
		}
		if(scroll.curTop > 2200 && scroll.curTop < 3800)
		{
			ctx.globalCompositeOperation = "multiply";
			ctx.globalAlpha = alphaFB;
		}
		ctx.drawImage(motionFondoBebe,
			sx * (test.camino[30].x - sy * (motionFondoBebe.width - 60) ),
			sy * (test.camino[30].y),
			sy * motionFondoBebe.width,
			sy * motionFondoBebe.height);
			//Dibuja el Bebe aumentando el alpha segun el scroll luego de haber terminado el contrno
			if(scroll.curTop < 3900)
			{
				ctx.globalAlpha = 0;
			}
			if(scroll.curTop > 3900 && scroll.curTop < 5400)
			{
				ctx.globalCompositeOperation = "multiply";
				ctx.globalAlpha = alphaB;
			}
			ctx.drawImage(motionBebe,
				sx * (test.camino[30].x - sy * (motionBebe.width - 50) ),
				sy * (test.camino[30].y + sy * 15),
				sy * motionBebe.width * 0.99,
				sy * motionBebe.height * 0.99);
				var frameWidth2 = 2000 / test.camino2.length;
				var frame2 = (scroll.curTop < 6400) ? Math.trunc((scroll.curTop - 5400) / frameWidth2) : test.camino2.length - 1;
				//Dibuja el camino por debajo del bebe
				for(i = 0; i <= frame2; i++)
				{
					var y = sy * test.camino2[i].y;
					var x = sx * test.camino2[i].x;
					var radius = sx * test.camino2[i].r;

					drawPath(x, y, radius);
				}

				//Dibuja la plabara Hallux
				if(scroll.curTop < 6400)
				{
					ctx.globalAlpha = 0;
				}
				if(scroll.curTop >= 6400 && scroll.curTop < 8000)
				{
					ctx.globalCompositeOperation = "multiply";
					ctx.globalAlpha = alphaH;
				}
				ctx.drawImage(motionHallux,
					sx * (test.camino2[25].x - sy * (motionHallux.width / 2 + 60) ),
					sy * (test.camino2[25].y + 40),
					sy * motionHallux.width,
					sy * motionHallux.height);
					//Dibuja el camino al pie
					var frameWidth3 = 1000 / test.camino3.length;
					var frame3 = (scroll.curTop < 9000) ? Math.trunc((scroll.curTop - 8000) / frameWidth3) : test.camino3.length - 1;
					for(i = 0; i <= frame3; i++)
					{
						var y = sy * test.camino3[i].y;
						var x = sx * test.camino3[i].x;
						var radius = sx * test.camino3[i].r;

						drawPath(x, y, radius);
					}
					//Dibuja la plabara Hallux
					if(scroll.curTop < 9000)
					{
						ctx.globalAlpha = 0;
					}
					if(scroll.curTop >= 9000 && scroll.curTop < 16000)
					{
						ctx.globalCompositeOperation = "multiply";
						ctx.globalAlpha = alphaJ;
					}
					ctx.drawImage(motionJuanete,
						sx * (test.camino3[8].x),
						sy * (test.camino3[8].y - motionJuanete.height),
						sy * motionJuanete.width,
						sy * motionJuanete.height);

	}

	// ********* SKROLLR *********
	test.skrollr = skrollr.init({
		smoothScrolling: true,
		smoothScrollingDuration: 1000,
		easing: "outCubic",
		render: function(data) {
			// Se analiza el estado de la pantalla en la vuelta actual
			//test.analizarRender(data);
			test.renderCamino(data);
		},
		constants: test.skrollrConstants
	});
	skrollr.get().animateTo( 1, { duration:0} );
	return test;
})(LIB, TIMELINEMENU, EVENTS);
